OGRE-Next: Memory

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Files | Classes | Typedefs | Enumerations | Functions
Memory
Core

## Files
file | OgreMemoryAllocatorConfig.h
| This file configures Ogre's memory allocators.

## Classes
class | Ogre::AlignedMemory
| Class to provide aligned memory allocate functionality. More...
class | Ogre::ArrayMemoryManager
| Abstract memory manager for managing large chunks of contiguous memory, optimized for SoA (Structure of Arrays) implementations. More...
class | Ogre::BoneArrayMemoryManager
| Implementation to create the Transform variables needed by Bones. More...
class | Ogre::BoneMemoryManager
| Wrap-around class that contains multiple ArrayMemoryManager, one per hierarchy depth. More...
class | Ogre::NodeArrayMemoryManager
| Implementation to create the Transform variables needed by Nodes & SceneNodes. More...
class | Ogre::NodeMemoryManager
| Wrap-around class that contains multiple ArrayMemoryManager, one per hierarchy depth. More...
class | Ogre::ObjectDataArrayMemoryManager
| Implementation to create the ObjectData variables needed by MovableObjects. More...
class | Ogre::ObjectMemoryManager
| Wrap-around class that contains multiple ArrayMemoryManager, one per render queue. More...
class | Ogre::STLAllocator< T, AllocPolicy >
struct | Ogre::STLAllocatorBase< T >
| Wrapper class for operating as an STL container allocator. More...
struct | Ogre::STLAllocatorBase< const T >

## Typedefs
typedef void(* | Ogre::CleanupRoutines) (char *dstPtr, size_t indexDst, char *srcPtr, size_t indexSrc, size_t numSlots, size_t numFreeSlots, size_t elementsMemSize)

## Enumerations
enum | Ogre::MemoryCategory { Ogre::MEMCATEGORY_GENERAL = 0 , Ogre::MEMCATEGORY_GEOMETRY = 1 , Ogre::MEMCATEGORY_ANIMATION = 2 , Ogre::MEMCATEGORY_SCENE_CONTROL = 3 , Ogre::MEMCATEGORY_SCENE_OBJECTS = 4 , Ogre::MEMCATEGORY_RESOURCE = 5 , Ogre::MEMCATEGORY_SCRIPTING = 6 , Ogre::MEMCATEGORY_RENDERSYS = 7 , Ogre::MEMCATEGORY_COUNT = 8 }
| A set of categories that indicate the purpose of a chunk of memory being allocated. More...

## Functions
void | Ogre::cleanerArrayAabb (char *dstPtr, size_t indexDst, char *srcPtr, size_t indexSrc, size_t numSlots, size_t numFreeSlots, size_t elementsMemSize)
void | Ogre::cleanerArrayQuaternion (char *dstPtr, size_t indexDst, char *srcPtr, size_t indexSrc, size_t numSlots, size_t numFreeSlots, size_t elementsMemSize)
void | Ogre::cleanerArrayVector3Unit (char *dstPtr, size_t indexDst, char *srcPtr, size_t indexSrc, size_t numSlots, size_t numFreeSlots, size_t elementsMemSize)
void | Ogre::cleanerArrayVector3Zero (char *dstPtr, size_t indexDst, char *srcPtr, size_t indexSrc, size_t numSlots, size_t numFreeSlots, size_t elementsMemSize)
void | Ogre::cleanerFlat (char *dstPtr, size_t indexDst, char *srcPtr, size_t indexSrc, size_t numSlots, size_t numFreeSlots, size_t elementsMemSize)
template<typename T>
T * | Ogre::constructN (T *basePtr, size_t count)
| Utility function for constructing an array of objects with placement new, without using new[] (which allocates an undocumented amount of extra memory and so isn't appropriate for custom allocators).
template<typename T, typename P, typename OtherAllocator>
bool | Ogre::operator!= (STLAllocator< T, P > const &, OtherAllocator const &)
| determine equality, can memory from another allocator be released by this allocator, (ISO C++)
template<typename T, typename T2, typename P>
bool | Ogre::operator!= (STLAllocator< T, P > const &, STLAllocator< T2, P > const &)
| determine equality, can memory from another allocator be released by this allocator, (ISO C++)
template<typename T, typename P, typename OtherAllocator>
bool | Ogre::operator== (STLAllocator< T, P > const &, OtherAllocator const &)
| determine equality, can memory from another allocator be released by this allocator, (ISO C++)
template<typename T, typename T2, typename P>
bool | Ogre::operator== (STLAllocator< T, P > const &, STLAllocator< T2, P > const &)
| determine equality, can memory from another allocator be released by this allocator, (ISO C++)

## Detailed Description

## Typedef Documentation

## ◆ CleanupRoutines

typedef void(* Ogre::CleanupRoutines) (char *dstPtr, size_t indexDst, char *srcPtr, size_t indexSrc, size_t numSlots, size_t numFreeSlots, size_t elementsMemSize)

## Enumeration Type Documentation

## ◆ MemoryCategory

enum Ogre::MemoryCategory

A set of categories that indicate the purpose of a chunk of memory being allocated.

These categories will be provided at allocation time in order to allow the allocation policy to vary its behaviour if it wishes. This allows you to use a single policy but still have variant behaviour. The level of control it gives you is at a higher level than assigning different policies to different classes, but is the only control you have over general allocations that are primitive types.

Enumerator
MEMCATEGORY_GENERAL | General purpose.
MEMCATEGORY_GEOMETRY | Geometry held in main memory.
MEMCATEGORY_ANIMATION | Animation data like tracks, bone matrices.
MEMCATEGORY_SCENE_CONTROL | Nodes, control data.
MEMCATEGORY_SCENE_OBJECTS | Scene object instances.
MEMCATEGORY_RESOURCE | Other resources.
MEMCATEGORY_SCRIPTING | Scripting.
MEMCATEGORY_RENDERSYS | Rendersystem structures.
MEMCATEGORY_COUNT |

## Function Documentation

## ◆ cleanerArrayAabb()

void Ogre::cleanerArrayAabb | ( | char * | dstPtr,
|  | size_t | indexDst,
|  | char * | srcPtr,
|  | size_t | indexSrc,
|  | size_t | numSlots,
|  | size_t | numFreeSlots,
|  | size_t | elementsMemSize )
| extern

## ◆ cleanerArrayQuaternion()

void Ogre::cleanerArrayQuaternion | ( | char * | dstPtr,
|  | size_t | indexDst,
|  | char * | srcPtr,
|  | size_t | indexSrc,
|  | size_t | numSlots,
|  | size_t | numFreeSlots,
|  | size_t | elementsMemSize )
| extern

## ◆ cleanerArrayVector3Unit()

void Ogre::cleanerArrayVector3Unit | ( | char * | dstPtr,
|  | size_t | indexDst,
|  | char * | srcPtr,
|  | size_t | indexSrc,
|  | size_t | numSlots,
|  | size_t | numFreeSlots,
|  | size_t | elementsMemSize )
| extern

## ◆ cleanerArrayVector3Zero()

void Ogre::cleanerArrayVector3Zero | ( | char * | dstPtr,
|  | size_t | indexDst,
|  | char * | srcPtr,
|  | size_t | indexSrc,
|  | size_t | numSlots,
|  | size_t | numFreeSlots,
|  | size_t | elementsMemSize )
| extern

## ◆ cleanerFlat()

void Ogre::cleanerFlat | ( | char * | dstPtr,
|  | size_t | indexDst,
|  | char * | srcPtr,
|  | size_t | indexSrc,
|  | size_t | numSlots,
|  | size_t | numFreeSlots,
|  | size_t | elementsMemSize )
| extern

## ◆ constructN()

template<typename T>

T * Ogre::constructN | ( | T * | basePtr,
|  | size_t | count )

Utility function for constructing an array of objects with placement new, without using new[] (which allocates an undocumented amount of extra memory and so isn't appropriate for custom allocators).

## ◆ operator!=() [1/2]

template<typename T, typename P, typename OtherAllocator>

bool Ogre::operator!= | ( | STLAllocator< T, P > const & | ,
|  | OtherAllocator const & | )
| inline

determine equality, can memory from another allocator be released by this allocator, (ISO C++)

## ◆ operator!=() [2/2]

template<typename T, typename T2, typename P>

bool Ogre::operator!= | ( | STLAllocator< T, P > const & | ,
|  | STLAllocator< T2, P > const & | )
| inline

determine equality, can memory from another allocator be released by this allocator, (ISO C++)

## ◆ operator==() [1/2]

template<typename T, typename P, typename OtherAllocator>

bool Ogre::operator== | ( | STLAllocator< T, P > const & | ,
|  | OtherAllocator const & | )
| inline

determine equality, can memory from another allocator be released by this allocator, (ISO C++)

## ◆ operator==() [2/2]

template<typename T, typename T2, typename P>

bool Ogre::operator== | ( | STLAllocator< T, P > const & | ,
|  | STLAllocator< T2, P > const & | )
| inline

determine equality, can memory from another allocator be released by this allocator, (ISO C++)